/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm p04010100.c                                */
/* aus "C fuer Java-Programmierer", Hanser-Verlag              */
/*                                                             */
/* Das Programm gibt eine Reihe von Konstanten aus, die die    */
/* Wertebereiche der skalaren Standardtypen definieren.        */
/***************************************************************/

#include <stdio.h>
#include <float.h>
#include <limits.h>

int main(void) {

 printf("<limits.h>\n\n");

 printf("char:\n\n");
 printf(" CHAR_BIT (Anzahl der Bits): %d\n\n",CHAR_BIT);
 printf(" CHAR_MIN (Minimaler Wert):  %d\n\n",CHAR_MIN);
 printf(" CHAR_MAX (Maximaler Wert):  %d\n\n",CHAR_MAX);
 printf(" sizeof(char): %d\n\n",sizeof(char));

 printf("signed char:\n\n");
 printf(" SCHAR_MIN (Minimaler Wert):  %d\n\n",SCHAR_MIN);
 printf(" SCHAR_MAX (Maximaler Wert):  %d\n\n",SCHAR_MAX);
 printf(" sizeof(signed char): %d\n\n",sizeof(signed char));

 printf("unsigned char:\n\n");
 printf(" UCHAR_MAX (Maximaler Wert):  %u\n\n",UCHAR_MAX);
 printf(" sizeof(unsigned char): %d\n\n",sizeof(unsigned char));

 printf("short:\n\n");
 printf(" SHRT_MIN (Minimaler Wert):  %d\n\n",SHRT_MIN);
 printf(" SHRT_MAX (Maximaler Wert):  %d\n\n",SHRT_MAX);
 printf(" sizeof(short): %d\n\n",sizeof(short));

 printf("unsigned short:\n\n");
 printf(" USHRT_MAX (Maximaler Wert):  %u\n\n",USHRT_MAX);
 printf(" sizeof(unsigned short): %d\n\n",sizeof(unsigned short));

 printf("int:\n\n");
 printf(" INT_MIN (Minimaler Wert):  %d\n\n",INT_MIN);
 printf(" INT_MAX (Maximaler Wert):  %d\n\n",INT_MAX);
 printf(" sizeof(int): %d\n\n",sizeof(int));

 printf("unsigned int:\n\n");
 printf(" UINT_MAX (Maximaler Wert):  %u\n\n",UINT_MAX);
 printf(" sizeof(unsigned int): %d\n\n",sizeof(unsigned int));

 printf("long:\n\n");
 printf(" LONG_MIN (Minimaler Wert):  %ld\n\n",LONG_MIN);
 printf(" LONG_MAX (Maximaler Wert):  %ld\n\n",LONG_MAX);
 printf(" sizeof(long): %d\n\n",sizeof(long));

 printf("unsigned long:\n\n");
 printf(" ULONG_MAX (Maximaler Wert):  %lu\n\n",ULONG_MAX);
 printf(" sizeof(unsigned long): %d\n\n",sizeof(unsigned long));

 printf("<float.h>\n\n");

 printf("float:\n\n");
 printf(" FLT_RADIX (Basis des Exponenten der Mantisse-Exponentdarstellung):  %d\n\n",FLT_RADIX);
 printf(" FLT_ROUNDS (Art der Rundung bei float-Addition):  %d\n\n",FLT_ROUNDS);
 printf(" FLT_DIG (Genauigkeit in Dezimalziffern):  %d\n\n",FLT_DIG);
 printf(" FLT_EPSILON (kleinstes x mit 1.0+x!=x):  %g\n\n",FLT_EPSILON);
 printf(" FLT_MANT_DIG (Anzahl der Ziffern in der Mantisse):  %d\n\n",FLT_MANT_DIG);
 printf(" FLT_MIN (Minimaler normalisierter Wert):  %g\n\n",FLT_MIN);
 printf(" FLT_MAX (Maximaler Wert):  %g\n\n",FLT_MAX);
 printf(" FLT_MIN_EXP (Kleinster negativer Exponent):  %d\n\n",FLT_MIN_EXP);
 printf(" FLT_MAX_EXP (Groesster positiver Exponent):  %d\n\n",FLT_MAX_EXP);
 printf(" sizeof(float): %d\n\n",sizeof(float));

 printf("double:\n\n");
 printf(" DBL_DIG (Genauigkeit in Dezimalziffern):  %d\n\n",DBL_DIG);
 printf(" DBL_EPSILON (kleinstes x mit 1.0+x!=x):  %g\n\n",DBL_EPSILON);
 printf(" DBL_MANT_DIG (Anzahl der Ziffern in der Mantisse):  %d\n\n",DBL_MANT_DIG);
 printf(" DBL_MIN (Minimaler normalisierter Wert):  %g\n\n",DBL_MIN);
 printf(" DBL_MAX (Maximaler Wert):  %g\n\n",DBL_MAX);
 printf(" DBL_MIN_EXP (Kleinster negativer Exponent):  %d\n\n",DBL_MIN_EXP);
 printf(" DBL_MAX_EXP (Groesster positiver Exponent):  %d\n\n",DBL_MAX_EXP);
 printf(" sizeof(double): %d\n\n",sizeof(double));

 printf("long double:\n\n");
 printf(" LDBL_DIG (Genauigkeit in Dezimalziffern):  %d\n\n",LDBL_DIG);
 printf(" LDBL_EPSILON (kleinstes x mit 1.0+x!=x):  %Lg\n\n",LDBL_EPSILON);
 printf(" LDBL_MANT_DIG (Anzahl der Ziffern in der Mantisse):  %d\n\n",LDBL_MANT_DIG);
 printf(" LDBL_MIN (Minimaler normalisierter Wert):  %Lg\n\n",LDBL_MIN);
 printf(" LDBL_MAX (Maximaler Wert):  %Lg\n\n",LDBL_MAX);
 printf(" LDBL_MIN_EXP (Kleinster negativer Exponent):  %d\n\n",LDBL_MIN_EXP);
 printf(" LDBL_MAX_EXP (Groesster positiver Exponent):  %d\n\n",LDBL_MAX_EXP);
 printf(" sizeof(long double): %d\n\n",sizeof(long double));

 return 0;
 
}

